--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-5
-- Time: 14:57
-- nmm text editor light color scheme.
--
-- color format 0xRRGGBB
-- style = {
--     font = "Font name",
--     size = 16, --font size
--     fore = 0xRRGGBB,  -- fore color
--     back = 0xRRGGBB,  -- back color
--     bold = true/false,-- font bold
--     italics = true/false, -- font italics
--     eolfilled = true/false,
--     underlined = true/false
-- }
--
local fonts = {}

local colors = {}

fonts.base = {
    --    Don't modify
    --Overridden by Preference
    font = "Monospace",
    --Overridden by Preference
    size = 14
}
--override base font
updateBaseFont(fonts.base)

fonts.comment = fonts.base
fonts.codeCommentBox = fonts.base
fonts.codeCommentLine = fonts.base
fonts.monospace = fonts.base


colors.codeCommentBox = { fore = 0x808080 }
colors.codeCommentLine = { fore = 0x808080 }
colors.codeCommentDocText = { fore = 0x808080 }
colors.codeCommentDocMarkup = { fore = 0xE2FFE2 }
colors.codeCommentDocValue = { fore = 0x3D3D3D }
colors.codeCommentNested = { fore = 0xA0C0A0 }
colors.textComment = { fore = 0x808080 }
colors.embeddedComment = { fore = 0xE0EEFF }
colors.otherComment = { fore = 0x007F00 }
colors.notused = { back = 0xFF0000 }
colors.textDefault = {
    fore = 0x000000,
    back = 0xFFFFFF
}
colors.lineNumber = {
    fore = 0x999999,
    back = 0xF2F2F2
}
colors.links = {
    fore = 0x0000FF,
    back = 0xE9E9E9
}
colors.number = { fore = 0x0000FF }
colors.keyword = { fore = 0x000080 }
colors.string = { fore = 0x008000 }
colors.metadata = { fore = 0x808000 }
colors.char = { fore = 0x008000 }
colors.badchar = { back = 0xFFCCCC }
colors.identifierDefault = {}
colors.identifierVar = {}
colors.identifierConst = { fore = 0x600E7A }

colors.classname = {}
colors.comma = {}

colors.declmethod = {}
colors.operator = {}
colors.preproc = { fore = 0x7F7F00 }
colors.error = {
    fore = 0xFFFF00,
    back = 0xFF0000
}
colors.braceMatchHighlight = {
    back = 0x99CCFF
}
colors.indentGuides = {
    fore = 0xC0C0C0,
    --    back = 0xFFFFFF
}
colors.fold = {
    fore = 0x999999,
    back = 0xF2F2F2
}
colors.foldHighlightColor = { fore = 0x00C0C0 }

colors.indicatorComposing = { fore = colors.textDefault.fore }

--AARRGGBB
colors.indicatorFindmarker = { fore = 0x50FFFF00 }

editor.settings.selection.usefore = true
colors.selection = {
    fore = 0xFFFFFF, -- Not used if editor.settings.selection.usefore is false
    back = 0x5974AB
}
colors.caret = {
    fore = 0xEC407A
}
colors.caretLineBack = {
    back = 0xFFFAE3
}
colors.whitespace = {
    fore = 0x999999
}

return function() return fonts, colors end
