--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-5
-- Time: 13:43
-- To change this template use File | Settings | File Templates.
--
local C = luajava.bindClass("jscintilla.lexers.c")
local keywords = {}

keywords[1] = [[
add and break case catch class continue default delete do
dynamic else eq extends false finally for function ge get gt if implements import in
instanceof interface intrinsic le lt ne new not null or private public return
set static super switch this throw true try typeof undefined var void while with
]]
keywords[2] = [[
Array Arguments Accessibility Boolean Button Camera Color
ContextMenu ContextMenuItem Date Error Function Key LoadVars LocalConnection Math
Microphone Mouse MovieClip MovieClipLoader NetConnection NetStream Number Object
PrintJob Selection SharedObject Sound Stage String StyleSheet System TextField
TextFormat TextSnapshot Video Void XML XMLNode XMLSocket
_accProps _focusrect _global _highquality _parent _quality _root _soundbuftime
arguments asfunction call capabilities chr clearInterval duplicateMovieClip
escape eval fscommand getProperty getTimer getURL getVersion gotoAndPlay gotoAndStop
ifFrameLoaded Infinity -Infinity int isFinite isNaN length loadMovie loadMovieNum
loadVariables loadVariablesNum maxscroll mbchr mblength mbord mbsubstring MMExecute
NaN newline nextFrame nextScene on onClipEvent onUpdate ord parseFloat parseInt play
prevFrame prevScene print printAsBitmap printAsBitmapNum printNum random removeMovieClip
scroll set setInterval setProperty startDrag stop stopAllSounds stopDrag substring
targetPath tellTarget toggleHighQuality trace unescape unloadMovie unLoadMovieNum updateAfterEvent
]]

local style = {}

--style[C.DEFAULT] =
--Comment: /* */.
style[C.COMMENT] = createStyle(fonts.codeCommentBox, colors.codeCommentBox, {})
--Line Comment: //.
style[C.COMMENTLINE] = createStyle(fonts.codeCommentLine, colors.codeCommentLine, {})
--Doc comment: block comments beginning with /** or /*
style[C.COMMENTDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})
--Number
style[C.NUMBER] = colors.number
--Keyword
style[C.WORD] = createChild(colors.keyword, { bold = true })
--Double quoted string
style[C.STRING] = colors.string
--Single quoted string
style[C.CHARACTER] = colors.char
--Preprocessor
style[C.PREPROCESSOR] = colors.preproc
--Operators
style[C.OPERATOR] = colors.operator
--style[C.IDENTIFIER] =

--End of line where string is not closed
style[C.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}

--Doc Comment Line: line comments beginning with /// or //!.
style[C.COMMENTLINEDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})

--keywords2 is for highlighting user defined keywords or function calls or similar
--Keywords2
style[C.WORD2] = { fore = 0xC0C0C0 }

--Comment keyword
style[C.COMMENTDOCKEYWORD] = { fore = 0xC0C0C0 }
--Comment keyword error
style[C.COMMENTDOCKEYWORDERROR] = { fore = 0xC0C0C0 }

--Global class
style[C.GLOBALCLASS] = { fore = 0xDD9900 }

--Preprocessor stream comment
style[C.PREPROCESSORCOMMENT] = { fore = 0x659900 }
--Preprocessor stream doc comment
style[C.PREPROCESSORCOMMENTDOC] = colors.codeCommentDocText
--User defined literals
style[C.USERLITERAL] = { fore = 0xC06000 }
style[C.TASKMARKER] = { fore = 0xBE07FF }
style[C.ESCAPESEQUENCE] = colors.string

local properties = {}

return function() return keywords, style, properties end
