--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-9
-- Time: 20:39
-- To change this template use File | Settings | File Templates.
--


local H = luajava.bindClass("jscintilla.lexers.h")
local keywords = {}


keywords[1] = [[
a abbr acronym address applet area b base basefont
bdo big blockquote body br button caption center
cite code col colgroup dd del dfn dir div dl dt em
fieldset font form frame frameset h1 h2 h3 h4 h5 h6
head hr html i iframe img input ins isindex kbd label
legend li link map menu meta noframes noscript
object ol optgroup option p param pre q s samp
script select small span strike strong style sub sup
table tbody td textarea tfoot th thead title tr tt u ul
var xml xmlns

abbr accept-charset accept accesskey action align alink
alt archive axis background bgcolor border
cellpadding cellspacing char charoff charset checked cite
class classid clear codebase codetype color cols colspan
compact content coords
data datafld dataformatas datapagesize datasrc datetime
declare defer dir disabled enctype event
face for frame frameborder
headers height href hreflang hspace http-equiv
id ismap label lang language leftmargin link longdesc
marginwidth marginheight maxlength media method multiple
name nohref noresize noshade nowrap
object onblur onchange onclick ondblclick onfocus
onkeydown onkeypress onkeyup onload onmousedown
onmousemove onmouseover onmouseout onmouseup
onreset onselect onsubmit onunload
profile prompt readonly rel rev rows rowspan rules
scheme scope selected shape size span src standby start style
summary tabindex target text title topmargin type usemap
valign value valuetype version vlink vspace width
text password checkbox radio submit reset
file hidden image
^data-

address article aside audio base canvas command details datalist embed
figure figcaption footer header hgroup keygen mark menu meter nav output
progress ruby rt rp section source time video wbr

async autocomplete autofocus contenteditable contextmenu draggable
form formaction formenctype formmethod formnovalidate formtarget
list manifest max min novalidate pattern placeholder
required reversed role sandbox scoped seamless sizes spellcheck srcdoc step

public !doctype
]]

--javascript
keywords[2] = [[
abstract boolean break byte case catch char class
const continue debugger default delete do double else enum export extends
final finally float for function goto if implements import in instanceof
int interface long native new package private protected public
return short static super switch synchronized this throw throws
transient try typeof var void volatile while with
]]

--vb
keywords[3] = [[
addressof alias and as attribute base begin binary boolean byref byte byval call case cdbl
cint clng compare const csng cstr currency date decimal declare defbool defbyte defcur
defdate defdbl defdec defint deflng defobj defsng defstr defvar dim do double each else
elseif empty end enum eqv erase error event exit explicit false for friend function get
global gosub goto if imp implements in input integer is len let lib like load lock long
loop lset me mid midb mod new next not nothing null object on option optional or paramarray
preserve print private property public raiseevent randomize redim rem resume return rset
seek select set single static step stop string sub text then time to true type typeof
unload until variant wend while with withevents xor
]]

--python
keywords[4] = [[
and as assert break class continue def del elif
else except exec finally for from global if import in is lambda not
or pass print raise return try while with yield

cdef cimport cpdef
]]

--php
keywords[5] = [[
and array as bool boolean break case cfunction class const continue declare
default die directory do double echo else elseif empty enddeclare endfor
endforeach endif endswitch endwhile eval exit extends false float for
foreach function global goto if include include_once int integer isset list namespace
new null object old_function or parent print real require require_once resource
return static stdclass string switch true unset use var while xor
abstract catch clone exception final implements interface php_user_filter
private protected public this throw try
__class__ __dir__ __file__ __function__ __line__ __method__
__namespace__ __sleep __wakeup
]]

keywords[6] = [[
ELEMENT DOCTYPE ATTLIST ENTITY NOTATION
]]


local style = {}

--style[H.DEFAULT] =
--style[H.TAG] =
style[H.TAGUNKNOWN] = {
    fore = 0xFF0000,
}
style[H.ATTRIBUTE] = {
    fore = 0x008080,
}
style[H.ATTRIBUTEUNKNOWN] = {
    fore = 0xFF0000,
}
style[H.NUMBER] = colors.number
style[H.DOUBLESTRING] = colors.string
style[H.SINGLESTRING] = colors.char
--Other inside tag, including space and '='
style[H.OTHER] = {
    fore = 0x800080,
}
style[H.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[H.ENTITY] = {
    fore = 0x800080,
}
--XML style tag ends '/>'
style[H.TAGEND] = {
    fore = 0x000080,
}
--XML identifier start '<?'
style[H.XMLSTART] = {
    fore = 0x0000FF,
}
--XML identifier end '?>'
style[H.XMLEND] = {
    fore = 0x0000FF,
}
--Internal state which should never be visible
style[H.SCRIPT] = {
    back = 0xFF0000,
}
--ASP < %... % >
style[H.ASP] = {
    back = 0xFFFF00,
}
--ASP < %... % >
style[H.ASPAT] = {
    back = 0xFFDF00,
}
style[H.CDATA] = {
    back = 0xFFDF00,
}
--php
style[H.QUESTION] = {
    fore = 0x0000FF,
    back = 0xFFEFBF,
}
--Unquoted values
style[H.VALUE] = {
    fore = 0xFF00FF,
    back = 0xFFEFFF,
}
--JSP Comment < % -- ... --%>
style[H.XCCOMMENT] = {
    fore = 0x000000,
    back = 0xFFFFD0,
}
--SGML tags < !... >
style[H.SGML_DEFAULT] = {
    fore = 0x000080,
}
--SGML command
style[H.SGML_COMMAND] = {
    fore = 0x000080,
    bold = true
}
style[H.SGML_1ST_PARAM] = {
    fore = 0x006600,
}
style[H.SGML_DOUBLESTRING] = {
    fore = 0x800000,
}
style[H.SGML_SIMPLESTRING] = {
    fore = 0x993300,
}
style[H.SGML_ERROR] = {
    fore = 0x800000,
    back = 0xFF6666,
}
--SGML special (#XXXX type)
style[H.SGML_SPECIAL] = {
    fore = 0x3366FF,
}
style[H.SGML_ENTITY] = {
    fore = 0x333333,
}
style[H.SGML_COMMENT] = {
    fore = 0x808000,
}
style[H.SGML_1ST_PARAM_COMMENT] = {
    fore = 0x808000,
    back = 0xFF0000,
}
style[H.SGML_BLOCK_DEFAULT] = {
    fore = 0x000066,
    back = 0xCCCCE0,
}


--html java script
local HJ = luajava.bindClass("jscintilla.lexers.hj")
--JS Start - allows eol filled background to not start on same line as SCRIPT tag
--style[HJ.START]=
--style[HJ.DEFAULT]=
style[HJ.COMMENT] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[HJ.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HJ.COMMENTDOC] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[HJ.NUMBER] = colors.number
--style[HJ.WORD] = colors.keyword
style[HJ.KEYWORD] = createChild(colors.keyword, {
    bold = true
})
style[HJ.DOUBLESTRING] = colors.string
style[HJ.SINGLESTRING] = colors.char
style[HJ.SYMBOLS] = colors.operator
style[HJ.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}
style[HJ.REGEX] = {
    back = 0xFFBBB0,
}

--ASP Javascript
local HJA = luajava.bindClass("jscintilla.lexers.hja")
--style[HJA.START] = {
--    fore = 0x7F7F00,
--}
--style[HJA.DEFAULT]=
style[HJA.COMMENT] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[HJA.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HJA.COMMENTDOC] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[HJA.NUMBER] = colors.number
--style[HJA.WORD] = colors.keyword
style[HJA.KEYWORD] = createChild(colors.keyword, {
    bold = true
})
style[HJA.DOUBLESTRING] = colors.string
style[HJA.SINGLESTRING] = colors.char
style[HJA.SYMBOLS] = colors.operator
style[HJA.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}
style[HJA.REGEX] = {
    back = 0xFFBBB0,
}


--Embedded VBS
local HB = luajava.bindClass("jscintilla.lexers.hb")

--style[HJ.START] =
--style[HJ.DEFAULT] =
style[HB.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HB.NUMBER] = colors.number
--style[HB.WORD] = colors.keyword
style[HB.STRING] = colors.string
--style[HB.IDENTIFIER] =
style[HB.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}

--ASP VBS
local HBA = luajava.bindClass("jscintilla.lexers.hba")

--style[HBA.START]=
--style[HBA.DEFAULT]=
style[HBA.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HBA.NUMBER] = colors.number
--style[HBA.WORD] = colors.keyword
style[HBA.STRING] = colors.string
--style[HBA.IDENTIFIER]=
style[HBA.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}

--Embedded Python
local HP = luajava.bindClass("jscintilla.lexers.hp")

style[HP.START] = {
    fore = 0x808080,
}
style[HP.DEFAULT] = {
    fore = 0x808080,
    eolfilled = true
}
style[HP.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HP.NUMBER] = colors.number
style[HP.STRING] = colors.string
style[HP.CHARACTER] = colors.char
--style[HP.WORD] = colors.keyword
style[HP.TRIPLE] = colors.string
style[HP.TRIPLEDOUBLE] = colors.string
style[HP.CLASSNAME] = {
    bold = true,
    eolfilled = true
}
style[HP.DEFNAME] = {
    bold = true,
    eolfilled = true
}
--style[HP.OPERATOR] =
--style[HP.IDENTIFIER] =

--ASP Python
local HPA = luajava.bindClass("jscintilla.lexers.hpa")

style[HPA.START] = {
    fore = 0x808080,
}
style[HPA.DEFAULT] = {
    fore = 0x808080,
    eolfilled = true
}
style[HPA.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HPA.NUMBER] = colors.number
style[HPA.STRING] = colors.string
style[HPA.CHARACTER] = colors.char
style[HPA.WORD] = colors.keyword
style[HPA.TRIPLE] = colors.string
style[HPA.TRIPLEDOUBLE] = colors.string
style[HPA.CLASSNAME] = {
    bold = true,
    eolfilled = true
}
style[HPA.DEFNAME] = {
    bold = true,
    eolfilled = true
}
--style[HPA.OPERATOR] =
--style[HPA.IDENTIFIER] =

local HPHP = luajava.bindClass("jscintilla.lexers.hphp")

style[HPHP.COMPLEX_VARIABLE] = {
    fore = 0x007F00,
    italics = true
}
--style[HPHP.DEFAULT] =
style[HPHP.HSTRING] = colors.string
style[HPHP.SIMPLESTRING] = colors.char
--style[HPHP.WORD] = colors.keyword
style[HPHP.NUMBER] = colors.number
style[HPHP.VARIABLE] = {
    bold = true,
    italics = true
}
style[HPHP.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HPHP.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[HPHP.HSTRING_VARIABLE] = {
    fore = 0x007F00,
    italics = true
}
style[HPHP.OPERATOR] = colors.operator




local properties = {}

properties["fold.html"] = "1"

return function() return keywords, style, properties end

