--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-5
-- Time: 13:43
-- To change this template use File | Settings | File Templates.
--
local C = luajava.bindClass("jscintilla.lexers.c")
local keywords = {}

keywords[1] = [[
aggregatable allocate appobject arrays async async_uuid
auto_handle
bindable boolean broadcast byte byte_count
call_as callback char coclass code comm_status
const context_handle context_handle_noserialize
context_handle_serialize control cpp_quote custom
decode default defaultbind defaultcollelem
defaultvalue defaultvtable dispinterface displaybind dllname
double dual
enable_allocate encode endpoint entry enum error_status_t
explicit_handle
fault_status first_is float
handle_t heap helpcontext helpfile helpstring
helpstringcontext helpstringdll hidden hyper
id idempotent ignore iid_as iid_is immediatebind implicit_handle
import importlib in include in_line int __int64 __int3264 interface
last_is lcid length_is library licensed local long
max_is maybe message methods midl_pragma
midl_user_allocate midl_user_free min_is module ms_union
ncacn_at_dsp ncacn_dnet_nsp ncacn_http ncacn_ip_tcp
ncacn_nb_ipx ncacn_nb_nb ncacn_nb_tcp ncacn_np
ncacn_spx ncacn_vns_spp ncadg_ip_udp ncadg_ipx ncadg_mq
ncalrpc nocode nonbrowsable noncreatable nonextensible notify
object odl oleautomation optimize optional out out_of_line
pipe pointer_default pragma properties propget propput propputref
ptr public
range readonly ref represent_as requestedit restricted retval
shape short signed size_is small source strict_context_handle
string struct switch switch_is switch_type
transmit_as typedef
uidefault union unique unsigned user_marshal usesgetlasterror uuid
v1_enum vararg version void wchar_t wire_marshal

attribute native noscript scriptable shared wstring inout
]]

local style = {}

--style[C.DEFAULT] =
--Comment: /* */.
style[C.COMMENT] = createStyle(fonts.codeCommentBox, colors.codeCommentBox, {})
--Line Comment: //.
style[C.COMMENTLINE] = createStyle(fonts.codeCommentLine, colors.codeCommentLine, {})
--Doc comment: block comments beginning with /** or /*
style[C.COMMENTDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})
--Number
style[C.NUMBER] = colors.number
--Keyword
style[C.WORD] = createChild(colors.keyword, { bold = true })
--Double quoted string
style[C.STRING] = colors.string
--Single quoted string
style[C.CHARACTER] = colors.char
--UUIDs (only in IDL)
style[C.UUID] = { fore = 0x804080 }
--Preprocessor
style[C.PREPROCESSOR] = colors.preproc
--Operators
style[C.OPERATOR] = colors.operator
--style[C.IDENTIFIER] =

--End of line where string is not closed
style[C.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}

--Doc Comment Line: line comments beginning with /// or //!.
style[C.COMMENTLINEDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})

--keywords2 is for highlighting user defined keywords or function calls or similar
--Keywords2
style[C.WORD2] = { fore = 0xC0C0C0 }

--Comment keyword
style[C.COMMENTDOCKEYWORD] = { fore = 0xC0C0C0 }
--Comment keyword error
style[C.COMMENTDOCKEYWORDERROR] = { fore = 0xC0C0C0 }


--Preprocessor stream comment
style[C.PREPROCESSORCOMMENT] = { fore = 0x659900 }
--Preprocessor stream doc comment
style[C.PREPROCESSORCOMMENTDOC] = colors.codeCommentDocText
--User defined literals
style[C.USERLITERAL] = { fore = 0xC06000 }
style[C.TASKMARKER] = { fore = 0xBE07FF }
style[C.ESCAPESEQUENCE] = colors.string

local properties = {}

return function() return keywords, style, properties end
