--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 20:40
-- To change this template use File | Settings | File Templates.
--


local LUA = luajava.bindClass("jscintilla.lexers.lua")
local keywords = {}

keywords[1] = [[
and break do else elseif
end for function if in
local nil not or repeat
return then until while true false
goto
]]
keywords[2] = [[
_ALERT assert call collectgarbage copytagmethods
dofile dostring error foreach foreachi
gcinfo getglobal getn gettagmethod globals
newtag next print rawget rawset
setglobal settag settagmethod sort tag
tonumber tostring tinsert tremove type
_VERSION _ERRORMESSAGE

assert collectgarbage dofile error _G
getmetatable ipairs loadfile next pairs
pcall print rawequal rawget rawset
setmetatable tonumber tostring type _VERSION
xpcall string table math coroutine io os debug

getfenv gcinfo loadlib loadstring require setfenv unpack _LOADED LUA_PATH _REQUIREDNAME

getfenv load loadstring select setfenv unpack package

load rawlen select package bit32 _ENV

load rawlen select package utf8 _ENV

getfenv gcinfo load loadlib loadstring
require select setfenv unpack
_LOADED LUA_PATH _REQUIREDNAME
package rawlen package bit32 utf8 _ENV

]]

keywords[3] = [[
strbyte strchar strfind strlen strlower
strrep strsub strupper format gsub
abs acos asin atan atan2
ceil cos deg exp floor
log log10 max min mod
rad sin sqrt tan frexp
ldexp random randomseed PI

string.byte string.char string.dump string.find string.format
string.gsub string.len string.lower string.rep string.sub string.upper
table.concat table.insert table.remove table.sort
math.abs math.acos math.asin math.atan math.atan2
math.ceil math.cos math.deg math.exp math.floor
math.frexp math.ldexp math.log math.max math.min
math.pi math.pow math.rad math.random math.randomseed
math.sin math.sqrt math.tan

string.gfind table.foreach table.foreachi table.getn table.setn math.mod math.log10

string.gmatch string.match string.reverse table.maxn math.cosh math.fmod math.huge math.log10 math.modf math.sinh math.tanh

bit32.arshift bit32.band bit32.bnot bit32.bor bit32.btest
bit32.bxor bit32.extract bit32.replace bit32.lrotate bit32.lshift
bit32.rrotate bit32.rshift

utf8.char utf8.charpattern utf8.codes
utf8.codepoint utf8.len utf8.offset

string.byte string.char string.dump string.find string.format
string.gmatch string.gsub string.len string.lower string.match
string.pack string.packsize string.rep
string.reverse string.sub string.unpack string.upper
table.concat table.insert table.move table.pack
table.remove table.sort table.unpack
math.abs math.acos math.asin math.atan
math.ceil math.cos math.deg math.exp
math.floor math.fmod math.huge
math.log math.max math.maxinteger math.min math.mininteger
math.modf math.pi math.rad
math.random math.randomseed math.sin
math.sqrt math.tan
math.tointeger math.type math.ult

]]
keywords[4] = [[
openfile closefile readfrom writeto appendto
remove rename flush seek tmpname read write
clock date execute exit getenv setlocale
_INPUT _OUTPUT _STDIN _STDOUT _STDERR -- file descriptors

coroutine.create coroutine.resume coroutine.status coroutine.wrap coroutine.yield
io.close io.flush io.input io.lines io.open
io.output io.read io.tmpfile io.type io.write
io.stdin io.stdout io.stderr
os.clock os.date os.difftime os.execute os.exit
os.getenv os.remove os.rename os.setlocale os.time
os.tmpname

require package.cpath package.loaded
package.loadlib package.path package.preload

coroutine.running io.popen module package.loaders package.seeall

coroutine.running io.popen package.config package.searchers package.searchpath

coroutine.isyieldable coroutine.running io.popen package.config package.searchers package.searchpath


]]
keywords[5] = [[
getinfo getlocal setlocal setcallhook setlinehook

debug.debug debug.gethook debug.getinfo debug.getlocal debug.getupvalue
debug.setlocal debug.setupvalue debug.sethook debug.traceback

debug.getfenv debug.getmetatable debug.getregistry debug.setfenv debug.setmetatable

debug.getmetatable debug.getregistry debug.setmetatable debug.getuservalue debug.setuservalue debug.upvalueid debug.upvaluejoin

]]

local style = {}


--style[LUA.DEFAULT] =
style[LUA.COMMENT] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[LUA.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[LUA.COMMENTDOC] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[LUA.NUMBER] = colors.number
style[LUA.WORD] = colors.keyword
--(Double quoted) String
style[LUA.STRING] = colors.string
--Character (Single quoted string)
style[LUA.CHARACTER] = colors.string
--Literal string
style[LUA.LITERALSTRING] = colors.string
--Preprocessor (obsolete in Lua 4.0 and up)
style[LUA.PREPROCESSOR] = colors.preproc
--Operators
style[LUA.OPERATOR] = colors.operator
--Identifier (everything else...)
--style[LUA.IDENTIFIER] =
--End of line where string is not closed
style[LUA.STRINGEOL] = createChild(colors.string, {
    back = 0xE0C0E0,
    eolfilled = true
})
style[LUA.WORD2] = colors.keyword
style[LUA.WORD3] = colors.keyword
style[LUA.WORD4] = colors.keyword
style[LUA.WORD5] = colors.keyword
style[LUA.WORD6] = colors.keyword
style[LUA.WORD7] = colors.keyword
style[LUA.WORD8] = colors.keyword
--style[LUA.LABEL] =


editor.settings.indent.starts = { "do", "else", "then", "{" }
editor.settings.indent.ends = { "end", "}" }


local properties = {}

return function() return keywords, style, properties end

