--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 19:36
-- To change this template use File | Settings | File Templates.
--

local PERL = luajava.bindClass("jscintilla.lexers.pl")
local keywords = {}

keywords[1] = [[
NULL __FILE__ __LINE__ __PACKAGE__ __DATA__ __END__ AUTOLOAD
BEGIN CORE DESTROY END EQ GE GT INIT LE LT NE CHECK abs accept
alarm and atan2 bind binmode bless caller chdir chmod chomp chop
chown chr chroot close closedir cmp connect continue cos crypt
dbmclose dbmopen defined delete die do dump each else elsif endgrent
endhostent endnetent endprotoent endpwent endservent eof eq eval
exec exists exit exp fcntl fileno flock for foreach fork format
formline ge getc getgrent getgrgid getgrnam gethostbyaddr gethostbyname
gethostent getlogin getnetbyaddr getnetbyname getnetent getpeername
getpgrp getppid getpriority getprotobyname getprotobynumber getprotoent
getpwent getpwnam getpwuid getservbyname getservbyport getservent
getsockname getsockopt glob gmtime goto grep gt hex if index
int ioctl join keys kill last lc lcfirst le length link listen
local localtime lock log lstat lt map mkdir msgctl msgget msgrcv
msgsnd my ne next no not oct open opendir or ord our pack package
pipe pop pos print printf prototype push quotemeta qu
rand read readdir readline readlink readpipe recv redo
ref rename require reset return reverse rewinddir rindex rmdir
scalar seek seekdir select semctl semget semop send setgrent
sethostent setnetent setpgrp setpriority setprotoent setpwent
setservent setsockopt shift shmctl shmget shmread shmwrite shutdown
sin sleep socket socketpair sort splice split sprintf sqrt srand
stat study sub substr symlink syscall sysopen sysread sysseek
system syswrite tell telldir tie tied time times truncate
uc ucfirst umask undef unless unlink unpack unshift untie until
use utime values vec wait waitpid wantarray warn while write
xor
given when default break say state UNITCHECK __SUB__ fc
]]


local style = {}

--style[PERL.DEFAULT] =
style[PERL.ERROR] = colors.error
style[PERL.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
--POD: = at beginning of line
style[PERL.POD] = {
    fore = 0x004000,
    back = 0xE0FFE0,
    eolfilled = true
}
style[PERL.NUMBER] = colors.number
style[PERL.WORD] = colors.keyword
--Double quoted string
style[PERL.STRING] = colors.string
--Single quoted string
style[PERL.CHARACTER] = colors.string
--Symbols / Punctuation. Currently not used by LexPerl.
style[PERL.PUNCTUATION] = colors.notused
--Preprocessor. Currently not used by LexPerl.
style[PERL.PREPROCESSOR] = colors.preproc
--Operators
style[PERL.OPERATOR] = colors.operator
--Identifiers (functions, etc.)
--style[PERL.IDENTIFIER] =
--Scalars: $var
style[PERL.SCALAR] = {
    fore = 0x000000,
    back = 0xFFE0E0,
}
--Array: @var
style[PERL.ARRAY] = {
    fore = 0x000000,
    back = 0xFFFFE0,
}
--Hash: %var
style[PERL.HASH] = {
    fore = 0x000000,
    back = 0xFFE0FF,
}
--Symbol table: *var
style[PERL.SYMBOLTABLE] = {
    fore = 0x000000,
    back = 0xE0E0E0,
}
--SCE_PL_VARIABLE_INDEXER allocated but unused
style[PERL.VARIABLE_INDEXER] = {
    back = 0xFF0000,
}
--Regex: /re/ or m{re}
style[PERL.REGEX] = {
    back = 0xA0FFA0,
}
--Substitution: s/re/ore/
style[PERL.REGSUBST] = {
    back = 0xF0E080,
}
--Long Quote (qq, qr, qw, qx) -- obsolete: replaced by qq, qx, qr, qw
style[PERL.LONGQUOTE] = {
    fore = 0xFFFF00,
    back = 0x8080A0,
}
--Back Ticks
style[PERL.BACKTICKS] = createChild(colors.string, {
    back = 0x90FFFF,
})
--Data Section: __DATA__ or __END__ at beginning of line
style[PERL.DATASECTION] = {
    fore = 0x600000,
    back = 0xFFF0D8,
    eolfilled = true
}
--Here-doc (delimiter)
style[PERL.HERE_DELIM] = {
    fore = 0x000000,
    back = 0xDDD0DD,
}
--Here-doc (single quoted, q)
style[PERL.HERE_Q] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
}
--Here-doc (double quoted, qq)
style[PERL.HERE_QQ] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
    eolfilled = true,
    bold = true
}
--Here-doc (back ticks, qx)
style[PERL.HERE_QX] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
    eolfilled = true,
    italics = true
}
--Single quoted string, generic
style[PERL.STRING_Q] = {
    fore = 0x7F007F,
    bold = false
}
--qq = Double quoted string
style[PERL.STRING_QQ] = colors.string
--qx = Back ticks
style[PERL.STRING_QX] = createChild(colors.string, {
    back = 0x90FFFF,
})
--qr = Regex
style[PERL.STRING_QR] = style[PERL.REGEX]
--qw = Array
style[PERL.STRING_QW] = style[PERL.ARRAY]
--POD: verbatim paragraphs
style[PERL.POD_VERB] = {
    fore = 0x004000,
    back = 0xC0FFC0,
    eolfilled = true
}
--subroutine prototype
style[PERL.SUB_PROTOTYPE] = {
    italics = true
}
--format identifier
style[PERL.FORMAT_IDENT] = {
    fore = 0xC000C0,
    bold = true
}
--format body
style[PERL.FORMAT] = {
    fore = 0xC000C0,
    back = 0xFFF0FF,
    eolfilled = true
}
--Double quoted string (interpolated variable)
style[PERL.STRING_VAR] = createChild(colors.string, {
    bold = true
})

--translation: tr{}{} y{}{}
style[PERL.XLAT] = style[PERL.REGSUBST]
--Regex: /re/ or m{re} (interpolated variable)
style[PERL.REGEX_VAR] = createChild(style[PERL.REGEX], {
    bold = true
})
--Substitution: s/re/ore/ (interpolated variable)
style[PERL.REGSUBST_VAR] = createChild(style[PERL.REGSUBST], {
    bold = true
})
--Back Ticks (interpolated variable)
style[PERL.BACKTICKS_VAR] = createChild(style[PERL.BACKTICKS], {
    bold = true
})
--Here-doc (double quoted, qq) (interpolated variable)
style[PERL.HERE_QQ_VAR] = createChild(style[PERL.HERE_QQ], {
    bold = true
})
--Here-doc (back ticks, qx) (interpolated variable)
style[PERL.HERE_QX_VAR] = style[PERL.HERE_QQ_VAR]
--qq = Double quoted string (interpolated variable)
style[PERL.STRING_QQ_VAR] = style[PERL.STRING_VAR]
--qx = Back ticks (interpolated variable)
style[PERL.STRING_QX_VAR] = style[PERL.BACKTICKS_VAR]
--qr = Regex (interpolated variable)
style[PERL.STRING_QR_VAR] = style[PERL.REGEX_VAR]


local properties = {}

return function() return keywords, style, properties end

