--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 20:22
-- To change this template use File | Settings | File Templates.
--

local LISP = luajava.bindClass("jscintilla.lexers.lisp")
local keywords = {}

keywords[1] = [[
 + - * / = < > <= >= =>
abs acos and angle append apply asin assoc assoc assq assv atan
begin boolean?
caar cadr call-with-current-continuation call/cc
call-with-input-file call-with-output-file call-with-values
car cdr
caar cadr cdar cddr
caaar caadr cadar caddr cdaar cdadr cddar cdddr
caaaar caaadr caadar caaddr cadaar cadadr caddar cadddr
cdaaar cdaadr cdadar cdaddr cddaar cddadr cdddar cddddr
case ceiling char->integer
char-alphabetic? char-ci< = ? char-ci<? char-ci=? char-ci>=? char-ci>?
char-downcase char-lower-case? char-numeric? char-ready?
char-upcase char-upper-case? char-whitespace?
char< = ? char<? char=? char>=? char>? char?
close-input-port close-output-port complex? cond cons cos
current-input-port current-output-port
define define-syntax delay denominator display do dynamic-wind
else eof-object? eq? equal? eqv? eval even? exact->inexact exact?
exp expt
floor for-each force
gcd
if imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment
lambda lcm length let let* let-syntax letrec letrec-syntax
list list->string list->vector list-ref list-tail list? load log
magnitude make-polar make-rectangular make-string make-vector
map max member memq memv min modulo
negative? newline not null-environment null? number->string number? numerator
odd? open-input-file open-output-file or output-port?
pair? peek-char input-port? output-port? positive? procedure?
quasiquote quote quotient
rational? rationalize read read-char real-part real? remainder reverse round
scheme-report-environment set! set-car! set-cdr! sin sqrt string
string->list string->number string->symbol string-append
string-ci< = ? string-ci<? string-ci=? string-ci>=? string-ci>?
string-copy string-fill! string-length string-ref string-set!
string< = ? string<? string=? string>=? string>? string?
substring symbol->string symbol? syntax-rules
transcript-off transcript-on truncate
unquote unquote-splicing
values vector vector->list vector-fill! vector-length vector-ref vector-set! vector?
with-input-from-file with-output-to-file write write-char
zero?
]]


local style = {}

--style[LISP.DEFAULT ] =
style[LISP.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[LISP.NUMBER] = colors.number
--Keyword
style[LISP.KEYWORD] = createChild(colors.keyword, {
    bold = true
})
--Keyword 2
style[LISP.KEYWORD_KW] = {
    fore = 0xEE00AA,
}
--Symbol
style[LISP.SYMBOL] = {
    fore = 0xDD9900,
}
style[LISP.STRING] = colors.string
--End of line where string is not closed
style[LISP.STRINGEOL] = {
    fore = 0x000000,
    back = 0xFEFECC,
    eolfilled = true
}
--Identifiers
--style[LISP.IDENTIFIER] =
style[LISP.OPERATOR] = colors.operator
style[LISP.SPECIAL] = {
    fore = 0x60AA00,
}
style[LISP.MULTI_COMMENT] = createStyle(fonts.comment, colors.codeCommentBox, {})


wordCharacters = characters.alpha .. characters.numeric .. "!$%&*/:<=>?^_~+-.@"

local properties = {}

return function() return keywords, style, properties end
