--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-20
-- Time: 5:33
-- To change this template use File | Settings | File Templates.
--

local VHDL = luajava.bindClass("jscintilla.lexers.vhdl")
local keywords = {}

keywords[1] = [[
access after alias all architecture array assert attribute begin block
body buffer bus case component configuration constant disconnect downto else elsif end entity exit file
for function generate generic group guarded if impure in inertial inout is label library linkage literal
loop map new next null of on open others out package port postponed procedure process pure range record
register reject report return select severity shared signal subtype then to transport type unaffected
units until use variable wait when while with
]]
keywords[2] = [[
 abs and mod nand nor not or rem rol ror sla sll sra srl xnor xor
]]
keywords[3] = [[
 left right low high ascending image value pos val succ pred leftof rightof base range reverse_range
 length delayed stable quiet transaction event active last_event last_active last_value driving
 driving_value simple_name path_name instance_name
]]
keywords[4] = [[
 now readline read writeline write endfile resolved to_bit to_bitvector to_stdulogic to_stdlogicvector
 to_stdulogicvector to_x01 to_x01z to_UX01 rising_edge falling_edge is_x shift_left shift_right rotate_left
 rotate_right resize to_integer to_unsigned to_signed std_match to_01
]]
keywords[5] = [[
 std ieee work standard textio std_logic_1164 std_logic_arith std_logic_misc std_logic_signed
 std_logic_textio std_logic_unsigned numeric_bit numeric_std math_complex math_real vital_primitives
 vital_timing
]]
keywords[6] = [[
 boolean bit character severity_level integer real time delay_length natural positive string bit_vector
 file_open_kind file_open_status line text side width std_ulogic std_ulogic_vector std_logic
 std_logic_vector X01 X01Z UX01 UX01Z unsigned signed
]]




local style = {}

--style[VHDL.DEFAULT] =
style[VHDL.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[VHDL.COMMENTLINEBANG] = createStyle(fonts.comment, colors.codeCommentLine, {
    fore = 0x3F7F3F
})
style[VHDL.NUMBER] = colors.number
style[VHDL.STRING] = colors.string
style[VHDL.OPERATOR] = colors.operator
--style[VHDL.IDENTIFIER] =
style[VHDL.STRINGEOL] = createChild(colors.string, {
    back = 0xE0C0E0,
    eolfilled = true
})
style[VHDL.KEYWORD] = createChild(colors.keyword, {
    bold = true
})
style[VHDL.STDOPERATOR] = {
    fore = 0x007F7F
}
style[VHDL.ATTRIBUTE] ={
    fore=0x804020
}
style[VHDL.STDFUNCTION] ={
    fore=0x808020
}
style[VHDL.STDPACKAGE] ={
    fore=0x208020
}
style[VHDL.STDTYPE] ={
    fore=0x208080
}
style[VHDL.USERWORD] ={
    fore=0x804020
}
style[VHDL.BLOCK_COMMENT] =createStyle(fonts.comment, colors.codeCommentBox, {})





local properties = {}

return function() return keywords, style, properties end
